//***************************************************************************
//*                      VFIX by Kan (kan@arrakis.es)                       *
//*     Source code of Protected Mode, VESA 2.0 and MOUSE not included      *
//***************************************************************************

#include <stdio.h>
#include <dos.h>
#include "pmode.h"
#include "vesa20.h"
#include "mouse.h"

static void drawbox(int x1,int y1,int x2,int y2,int border);
static void fillbox(int x1,int y1,int x2,int y2,int colour);
static void draw_mouse();
static void undrawmouse();
static void exitnow();
static void exitmouse();

mem mem1,mem2;
FILE *handle1;
char aa;
int bb,cc,dd,ee,ff,gg,hh,ii,jj;
int xx,yy,xx2,yy2;
char memmouse[16];
int xold,yold;
int scroll;

char letra[30]={
        0,0,0,0,0,
        0,0,0,0,0,
        0,0,0,0,0,
        0,0,0,0,0,
        0,0,0,0,0,
        0,0,0,0,0};

char letra8[30]={
        0,1,1,1,0,
        1,0,0,0,1,
        0,1,1,1,0,
        0,1,1,1,0,
        1,0,0,0,1,
        0,1,1,1,0};

char letra9[30]={
        1,1,1,1,1,
        1,0,0,0,1,
        1,1,1,1,1,
        0,0,0,0,1,
        0,0,0,0,1,
        0,0,0,0,1};

char letra2[30]={
        0,1,1,1,0,
        1,0,0,0,1,
        0,0,0,1,0,
        0,0,1,0,0,
        0,1,0,0,0,
        1,1,1,1,1};

char letrabarra[30]={
        0,0,0,0,1,
        0,0,0,1,0,
        0,0,1,0,0,
        0,0,1,0,0,
        0,1,0,0,0,
        1,0,0,0,0};

char letra5[30]={
        1,1,1,1,1,
        1,0,0,0,0,
        1,1,1,1,0,
        0,0,0,0,1,
        0,0,0,0,1,
        1,1,1,1,0};

char letrapto[30]={
        0,0,0,0,0,
        0,0,0,0,0,
        0,0,0,0,0,
        0,1,1,1,0,
        0,1,1,1,0,
        0,1,1,1,0};

char letras[30]={
        0,1,1,1,1,
        1,0,0,0,0,
        0,1,1,0,0,
        0,0,1,1,0,
        0,0,0,0,1,
        1,1,1,1,0};

char letrar[30]={
        1,1,1,1,0,
        1,0,0,0,1,
        1,1,1,1,0,
        1,0,1,0,0,
        1,0,0,1,0,
        1,0,0,0,1};

char letraalgarroba[30]={
        0,1,1,1,1,
        1,0,1,0,1,
        1,0,1,0,1,
        1,0,1,1,1,
        1,0,0,0,0,
        0,1,1,1,1};

char letral[30]={
        1,0,0,0,0,
        1,0,0,0,0,
        1,0,0,0,0,
        1,0,0,0,0,
        1,0,0,0,0,
        1,1,1,1,1};

char letram[30]={
        1,0,0,0,1,
        1,1,0,1,1,
        1,0,1,0,1,
        1,0,0,0,1,
        1,0,0,0,1,
        1,0,0,0,1};

char letrae[30]={
        1,1,1,1,1,
        1,0,0,0,0,
        1,1,1,0,0,
        1,1,1,0,0,
        1,0,0,0,0,
        1,1,1,1,1};

char letradptos[30]={
        0,0,0,0,0,
        0,1,1,1,0,
        0,1,1,1,0,
        0,0,0,0,0,
        0,1,1,1,0,
        0,1,1,1,0};

char letramenos[30]={
        0,0,0,0,0,
        0,0,0,0,0,
        1,1,1,1,1,
        1,1,1,1,1,
        0,0,0,0,0,
        0,0,0,0,0};

char letrav[30]={
        1,0,0,0,1,
        1,0,0,0,1,
        0,1,0,1,0,
        0,1,0,1,0,
        0,1,0,1,0,
        0,0,1,0,0};

char letraf[30]={
        1,1,1,1,1,
        1,0,0,0,0,
        1,1,1,0,0,
        1,0,0,0,0,
        1,0,0,0,0,
        1,0,0,0,0};

char letrai[30]={
        1,1,1,1,1,
        0,0,1,0,0,
        0,0,1,0,0,
        0,0,1,0,0,
        0,0,1,0,0,
        1,1,1,1,1};

char letrax[30]={
        1,0,0,0,1,
        0,1,0,1,0,
        0,0,1,0,0,
        0,0,1,0,0,
        0,1,0,1,0,
        1,0,0,0,1};

char letrab[30]={
        1,1,1,1,0,
        1,0,0,0,1,
        1,1,1,1,0,
        1,1,1,1,0,
        1,0,0,0,1,
        1,1,1,1,0};

char letray[30]={
        1,0,0,0,1,
        0,1,0,1,0,
        0,0,1,0,0,
        0,0,1,0,0,
        0,0,1,0,0,
        0,0,1,0,0};

char letrak[30]={
        1,0,0,1,0,
        1,0,1,0,0,
        1,1,0,0,0,
        1,0,1,0,0,
        1,0,0,1,0,
        1,0,0,0,1};

char letraa[30]={
        0,1,1,1,0,
        1,0,0,0,1,
        1,1,1,1,1,
        1,0,0,0,1,
        1,0,0,0,1,
        1,0,0,0,1};

char letran[30]={
        1,0,0,0,1,
        1,1,0,0,1,
        1,0,1,0,1,
        1,0,1,0,1,
        1,0,0,1,1,
        1,0,0,0,1};

static void drawfix();
static void drawwords();

main(int argc,char *argv[])
{
 machine_setup();
 if(env_type==95)
 {
 printf("This program fortunately cannot be run in W95 mode.");
 return 1;
 }
 vesa20_setup();
 if(VESA20.version<0x200) {printf("\nVESA 2.0 not detected (error)."); exit(1);}
 vesa20_setvideomode(320,240,8,0x11E);
 pm_getmem(132000,&mem1);
 if (argv[1]==0) exitnow();
 handle1=fopen(argv[1],"rb");
 if (handle1==NULL) exitnow();
 fread((char *)mem1.linear,131072L,1,handle1);
 fclose(handle1);
 drawfix();
 drawbox(0,230,319,239,31);
 fillbox(1,231,318,238,1);
 if (mouse_detect()==0) exitmouse();
 limit_mouse(315*8,235*8);
 drawfix();
 draw_mouse();
 drawwords();
 while (!kbhit())
 {
 vesa20_waitretrace();
 undrawmouse();
 if (button_mouse()==1 && scroll<=104) { scroll++; drawfix(); }
 else if (button_mouse()==2 && scroll>=1) { scroll--; drawfix(); }
 draw_mouse();
 }
 fflush(stdin);
 pm_freemem(&mem1);
 vesa20_closevideomode(); 
 setvideo(0x3);
 printf("ͻ");
 printf("                    VFIX - A viewer for FIX files of Neo Geo                  ");
 printf("                                 By Kan - 5/2/98                              ");
 printf("                              Email: kan@arrakis.es                           ");
 printf("          http://www.geocities.com/SiliconValley/Way/7747/neopc.htm           ");
 printf("ͼ\n");

 return 1;
}

static void exitnow()
{
 pm_freemem(&mem1);
 vesa20_closevideomode(); 
 setvideo(0x3);
 printf("\nFile not found (error).\n");
 printf("\nRemember: VFIX namefile\n");
 exit(1);
}

static void exitmouse()
{
 pm_freemem(&mem1);
 vesa20_closevideomode(); 
 setvideo(0x3);
 printf("\nMouse not detected (error).\n");
 exit(1);
}

static void drawbox(int x1,int y1,int x2,int y2,int border)
{
 int i;

 for (i=x1; i<x2+1; i++)
        VESA20.lfb[i+y1*320]=border;
 for (i=x1; i<x2+1; i++)
        VESA20.lfb[i+y2*320]=border;
 for (i=y1; i<y2+1; i++)
        VESA20.lfb[x1+i*320]=border;
 for (i=y1; i<y2+1; i++)
        VESA20.lfb[x2+i*320]=border;
}

static void fillbox(int x1,int y1,int x2,int y2,int colour)
{
 int i,j;

 for (j=y1; j<y2+1; j++)
        for (i=x1; i<x2+1; i++)
                VESA20.lfb[i+j*320]=colour;
}

static void draw_mouse()
{
 int xmous,ymous;

 xold=xmous=x_mouse();
 yold=ymous=y_mouse();
 memmouse[1]=VESA20.lfb[(xmous+1)+ymous*320];
 VESA20.lfb[(xmous+1)+ymous*320]=12;
 memmouse[2]=VESA20.lfb[(xmous+2)+ymous*320];
 VESA20.lfb[(xmous+2)+ymous*320]=12;
 memmouse[4]=VESA20.lfb[xmous+(ymous+1)*320];
 VESA20.lfb[xmous+(ymous+1)*320]=12;
 memmouse[5]=VESA20.lfb[(xmous+1)+(ymous+1)*320];
 VESA20.lfb[(xmous+1)+(ymous+1)*320]=12;
 memmouse[6]=VESA20.lfb[(xmous+2)+(ymous+1)*320];
 VESA20.lfb[(xmous+2)+(ymous+1)*320]=12;
 memmouse[7]=VESA20.lfb[(xmous+3)+(ymous+1)*320];
 VESA20.lfb[(xmous+3)+(ymous+1)*320]=12;
 memmouse[8]=VESA20.lfb[xmous+(ymous+2)*320];
 VESA20.lfb[xmous+(ymous+2)*320]=12;
 memmouse[9]=VESA20.lfb[(xmous+1)+(ymous+2)*320];
 VESA20.lfb[(xmous+1)+(ymous+2)*320]=12;
 memmouse[10]=VESA20.lfb[(xmous+2)+(ymous+2)*320];
 VESA20.lfb[(xmous+2)+(ymous+2)*320]=12;
 memmouse[11]=VESA20.lfb[(xmous+3)+(ymous+2)*320];
 VESA20.lfb[(xmous+3)+(ymous+2)*320]=12;
 memmouse[13]=VESA20.lfb[(xmous+1)+(ymous+3)*320];
 VESA20.lfb[(xmous+1)+(ymous+3)*320]=12;
 memmouse[14]=VESA20.lfb[(xmous+2)+(ymous+3)*320];
 VESA20.lfb[(xmous+2)+(ymous+3)*320]=12;
}

static void undrawmouse()
{
 VESA20.lfb[(xold+1)+yold*320]=memmouse[1];
 VESA20.lfb[(xold+2)+yold*320]=memmouse[2];
 VESA20.lfb[xold+(yold+1)*320]=memmouse[4];
 VESA20.lfb[(xold+1)+(yold+1)*320]=memmouse[5];
 VESA20.lfb[(xold+2)+(yold+1)*320]=memmouse[6];
 VESA20.lfb[(xold+3)+(yold+1)*320]=memmouse[7];
 VESA20.lfb[xold+(yold+2)*320]=memmouse[8];
 VESA20.lfb[(xold+1)+(yold+2)*320]=memmouse[9];
 VESA20.lfb[(xold+2)+(yold+2)*320]=memmouse[10];
 VESA20.lfb[(xold+3)+(yold+2)*320]=memmouse[11];
 VESA20.lfb[(xold+1)+(yold+3)*320]=memmouse[13];
 VESA20.lfb[(xold+2)+(yold+3)*320]=memmouse[14];
}

static void drawfix()
{
 xx2=yy2=xx=yy=0;
 ee=0;
 gg=0+scroll*8*4*32;
 for (hh=0; hh<23; hh++)
 {
   for (ff=0; ff<32; ff++)
   {
     ii=yy;
     jj=xx;
     xx+=8;
     for (dd=0; dd<2; dd++)
     {
     xx-=2;
        for (bb=gg; bb<gg+8; bb++)
        {
        aa=mem1.ptr[bb]&0xF0;
        aa=aa>>4;
        VESA20.lfb[xx+yy*320]=aa;
        xx--;
        aa=mem1.ptr[bb]&0x0F;
        VESA20.lfb[xx+yy*320]=aa;
        xx++;
        yy++;
        }
     yy=ii;
     gg+=8;
     xx+=2;
        for (bb=gg; bb<gg+8; bb++)
        {
        aa=mem1.ptr[bb]&0xF0;
        aa=aa>>4;
        VESA20.lfb[xx+yy*320]=aa;
        xx--;
        aa=mem1.ptr[bb]&0x0F;
        VESA20.lfb[xx+yy*320]=aa;
        xx++;
        yy++;
        }
     xx-=4;
     yy=ii;
     gg+=8;
     }
   yy=ii;
   xx=jj;
   xx+=10;
   ee++;
   }
 ee=0;
 yy+=10;
 xx=0;
 }
}

static void drawwords()
{
int xc,yc,i,j;

 xc=2;
 yc=232;
 for (j=0; j<6; j++)
 {
        for (i=0; i<5; i++)
        {
        if (letrav[i+j*5]) VESA20.lfb[xc+yc*320]=31;
        xc++;
        }
 xc-=5;
 yc++;
 }
 xc=8;
 yc=232;
 for (j=0; j<6; j++)
 {
        for (i=0; i<5; i++)
        {
        if (letraf[i+j*5]) VESA20.lfb[xc+yc*320]=31;
        xc++;
        }
 xc-=5;
 yc++;
 }
 xc=14;
 yc=232;
 for (j=0; j<6; j++)
 {
        for (i=0; i<5; i++)
        {
        if (letrai[i+j*5]) VESA20.lfb[xc+yc*320]=31;
        xc++;
        }
 xc-=5;
 yc++;
 }
 xc=20;
 yc=232;
 for (j=0; j<6; j++)
 {
        for (i=0; i<5; i++)
        {
        if (letrax[i+j*5]) VESA20.lfb[xc+yc*320]=31;
        xc++;
        }
 xc-=5;
 yc++;
 }
 xc=26;
 yc=232;
 for (j=0; j<6; j++)
 {
        for (i=0; i<5; i++)
        {
        if (letra[i+j*5]) VESA20.lfb[xc+yc*320]=31;
        xc++;
        }
 xc-=5;
 yc++;
 }
 xc=32;
 yc=232;
 for (j=0; j<6; j++)
 {
        for (i=0; i<5; i++)
        {
        if (letrab[i+j*5]) VESA20.lfb[xc+yc*320]=31;
        xc++;
        }
 xc-=5;
 yc++;
 }
 xc=38;
 yc=232;
 for (j=0; j<6; j++)
 {
        for (i=0; i<5; i++)
        {
        if (letray[i+j*5]) VESA20.lfb[xc+yc*320]=31;
        xc++;
        }
 xc-=5;
 yc++;
 }
 xc=44;
 yc=232;
 for (j=0; j<6; j++)
 {
        for (i=0; i<5; i++)
        {
        if (letra[i+j*5]) VESA20.lfb[xc+yc*320]=31;
        xc++;
        }
 xc-=5;
 yc++;
 }
 xc=50;
 yc=232;
 for (j=0; j<6; j++)
 {
        for (i=0; i<5; i++)
        {
        if (letrak[i+j*5]) VESA20.lfb[xc+yc*320]=31;
        xc++;
        }
 xc-=5;
 yc++;
 }
 xc=56;
 yc=232;
 for (j=0; j<6; j++)
 {
        for (i=0; i<5; i++)
        {
        if (letraa[i+j*5]) VESA20.lfb[xc+yc*320]=31;
        xc++;
        }
 xc-=5;
 yc++;
 }
 xc=62;
 yc=232;
 for (j=0; j<6; j++)
 {
        for (i=0; i<5; i++)
        {
        if (letran[i+j*5]) VESA20.lfb[xc+yc*320]=31;
        xc++;
        }
 xc-=5;
 yc++;
 }
 xc=68;
 yc=232;
 for (j=0; j<6; j++)
 {
        for (i=0; i<5; i++)
        {
        if (letra[i+j*5]) VESA20.lfb[xc+yc*320]=31;
        xc++;
        }
 xc-=5;
 yc++;
 }
 xc=74;
 yc=232;
 for (j=0; j<6; j++)
 {
        for (i=0; i<5; i++)
        {
        if (letramenos[i+j*5]) VESA20.lfb[xc+yc*320]=31;
        xc++;
        }
 xc-=5;
 yc++;
 }
 xc=80;
 yc=232;
 for (j=0; j<6; j++)
 {
        for (i=0; i<5; i++)
        {
        if (letra[i+j*5]) VESA20.lfb[xc+yc*320]=31;
        xc++;
        }
 xc-=5;
 yc++;
 }
 xc=86;
 yc=232;
 for (j=0; j<6; j++)
 {
        for (i=0; i<5; i++)
        {
        if (letrae[i+j*5]) VESA20.lfb[xc+yc*320]=31;
        xc++;
        }
 xc-=5;
 yc++;
 }
 xc=92;
 yc=232;
 for (j=0; j<6; j++)
 {
        for (i=0; i<5; i++)
        {
        if (letram[i+j*5]) VESA20.lfb[xc+yc*320]=31;
        xc++;
        }
 xc-=5;
 yc++;
 }
 xc=98;
 yc=232;
 for (j=0; j<6; j++)
 {
        for (i=0; i<5; i++)
        {
        if (letraa[i+j*5]) VESA20.lfb[xc+yc*320]=31;
        xc++;
        }
 xc-=5;
 yc++;
 }
 xc=104;
 yc=232;
 for (j=0; j<6; j++)
 {
        for (i=0; i<5; i++)
        {
        if (letrai[i+j*5]) VESA20.lfb[xc+yc*320]=31;
        xc++;
        }
 xc-=5;
 yc++;
 }
 xc=110;
 yc=232;
 for (j=0; j<6; j++)
 {
        for (i=0; i<5; i++)
        {
        if (letral[i+j*5]) VESA20.lfb[xc+yc*320]=31;
        xc++;
        }
 xc-=5;
 yc++;
 }
 xc=116;
 yc=232;
 for (j=0; j<6; j++)
 {
        for (i=0; i<5; i++)
        {
        if (letradptos[i+j*5]) VESA20.lfb[xc+yc*320]=31;
        xc++;
        }
 xc-=5;
 yc++;
 }
 xc=122;
 yc=232;
 for (j=0; j<6; j++)
 {
        for (i=0; i<5; i++)
        {
        if (letra[i+j*5]) VESA20.lfb[xc+yc*320]=31;
        xc++;
        }
 xc-=5;
 yc++;
 }
 xc=128;
 yc=232;
 for (j=0; j<6; j++)
 {
        for (i=0; i<5; i++)
        {
        if (letrak[i+j*5]) VESA20.lfb[xc+yc*320]=31;
        xc++;
        }
 xc-=5;
 yc++;
 }
 xc=134;
 yc=232;
 for (j=0; j<6; j++)
 {
        for (i=0; i<5; i++)
        {
        if (letraa[i+j*5]) VESA20.lfb[xc+yc*320]=31;
        xc++;
        }
 xc-=5;
 yc++;
 }
 xc=140;
 yc=232;
 for (j=0; j<6; j++)
 {
        for (i=0; i<5; i++)
        {
        if (letran[i+j*5]) VESA20.lfb[xc+yc*320]=31;
        xc++;
        }
 xc-=5;
 yc++;
 }
 xc=146;
 yc=232;
 for (j=0; j<6; j++)
 {
        for (i=0; i<5; i++)
        {
        if (letraalgarroba[i+j*5]) VESA20.lfb[xc+yc*320]=31;
        xc++;
        }
 xc-=5;
 yc++;
 }
 xc=152;
 yc=232;
 for (j=0; j<6; j++)
 {
        for (i=0; i<5; i++)
        {
        if (letraa[i+j*5]) VESA20.lfb[xc+yc*320]=31;
        xc++;
        }
 xc-=5;
 yc++;
 }
 xc=158;
 yc=232;
 for (j=0; j<6; j++)
 {
        for (i=0; i<5; i++)
        {
        if (letrar[i+j*5]) VESA20.lfb[xc+yc*320]=31;
        xc++;
        }
 xc-=5;
 yc++;
 }
 xc=164;
 yc=232;
 for (j=0; j<6; j++)
 {
        for (i=0; i<5; i++)
        {
        if (letrar[i+j*5]) VESA20.lfb[xc+yc*320]=31;
        xc++;
        }
 xc-=5;
 yc++;
 }
 xc=170;
 yc=232;
 for (j=0; j<6; j++)
 {
        for (i=0; i<5; i++)
        {
        if (letraa[i+j*5]) VESA20.lfb[xc+yc*320]=31;
        xc++;
        }
 xc-=5;
 yc++;
 }
 xc=176;
 yc=232;
 for (j=0; j<6; j++)
 {
        for (i=0; i<5; i++)
        {
        if (letrak[i+j*5]) VESA20.lfb[xc+yc*320]=31;
        xc++;
        }
 xc-=5;
 yc++;
 }
 xc=182;
 yc=232;
 for (j=0; j<6; j++)
 {
        for (i=0; i<5; i++)
        {
        if (letrai[i+j*5]) VESA20.lfb[xc+yc*320]=31;
        xc++;
        }
 xc-=5;
 yc++;
 }
 xc=188;
 yc=232;
 for (j=0; j<6; j++)
 {
        for (i=0; i<5; i++)
        {
        if (letras[i+j*5]) VESA20.lfb[xc+yc*320]=31;
        xc++;
        }
 xc-=5;
 yc++;
 }
 xc=194;
 yc=232;
 for (j=0; j<6; j++)
 {
        for (i=0; i<5; i++)
        {
        if (letrapto[i+j*5]) VESA20.lfb[xc+yc*320]=31;
        xc++;
        }
 xc-=5;
 yc++;
 }
 xc=200;
 yc=232;
 for (j=0; j<6; j++)
 {
        for (i=0; i<5; i++)
        {
        if (letrae[i+j*5]) VESA20.lfb[xc+yc*320]=31;
        xc++;
        }
 xc-=5;
 yc++;
 }
 xc=206;
 yc=232;
 for (j=0; j<6; j++)
 {
        for (i=0; i<5; i++)
        {
        if (letras[i+j*5]) VESA20.lfb[xc+yc*320]=31;
        xc++;
        }
 xc-=5;
 yc++;
 }
 xc=283;
 yc=232;
 for (j=0; j<6; j++)
 {
        for (i=0; i<5; i++)
        {
        if (letra5[i+j*5]) VESA20.lfb[xc+yc*320]=31;
        xc++;
        }
 xc-=5;
 yc++;
 }
 xc=289;
 yc=232;
 for (j=0; j<6; j++)
 {
        for (i=0; i<5; i++)
        {
        if (letrabarra[i+j*5]) VESA20.lfb[xc+yc*320]=31;
        xc++;
        }
 xc-=5;
 yc++;
 }
 xc=295;
 yc=232;
 for (j=0; j<6; j++)
 {
        for (i=0; i<5; i++)
        {
        if (letra2[i+j*5]) VESA20.lfb[xc+yc*320]=31;
        xc++;
        }
 xc-=5;
 yc++;
 }
 xc=301;
 yc=232;
 for (j=0; j<6; j++)
 {
        for (i=0; i<5; i++)
        {
        if (letrabarra[i+j*5]) VESA20.lfb[xc+yc*320]=31;
        xc++;
        }
 xc-=5;
 yc++;
 }
 xc=307;
 yc=232;
 for (j=0; j<6; j++)
 {
        for (i=0; i<5; i++)
        {
        if (letra9[i+j*5]) VESA20.lfb[xc+yc*320]=31;
        xc++;
        }
 xc-=5;
 yc++;
 }
 xc=313;
 yc=232;
 for (j=0; j<6; j++)
 {
        for (i=0; i<5; i++)
        {
        if (letra8[i+j*5]) VESA20.lfb[xc+yc*320]=31;
        xc++;
        }
 xc-=5;
 yc++;
 }
}
